#!/bin/bash
# ļ: Nginx_Install.sh
# : Nginx Դ밲װű
# : Shuhui
# 汾: v1.3

### ־ ###

# 2015-12-20 汾 v1.0:  1. http2 ֧(nginx ) 
#                        2. nginx --with-threads ѡ
#                        3. nginx --with-file-aio ѡ
#                        4. nginx --with-pcre-jit ѡ 

# 2015-12-25 汾 v1.1:  1. Ϊ nginx  systemd ű

# 2016-01-20 汾 v1.2:  1. tengine 汾Ϊ 2.1.2

# 2016-03-02 汾 v1.3:  1. openssl 汾Ϊ 1.0.2g 
#                        2. Nginx 汾Ϊ 1.9.12
#                        3.  Nginx Ϊȱʡװ
#                        4. ȥϵͳںŻ
#                        5.  wget 滻 curl


###  
ZLIB_VER="1.2.8"                                # zlib 汾
PCRE_VER="8.37"                                 # pcre 汾
OPENSSL_VER="1.0.2g"                            # openssl 汾
NGINX_VER="1.13.3"                              # nginx 汾
JEMALLOC_VER="3.6.0"                            # jemalloc 汾
TENGINE_VER="2.1.2"                             # tengine 汾

PREFIX="/usr/local"                             # װ·
OWER="www"                                      #  nginx û
SRC="$PWD"                                      # ǰλñ

CPU_CORE=$(grep -c process /proc/cpuinfo)       # make ߳[cpu ]


# 鵱ǰûǷΪ root
if [ ${UID} != '0' ]
then
	echo "Error: Please use root role to install me!"
    exit 1
fi

function Yum_Depend()
{
	# װ Nginx 
	for NGINX_PKG in gcc gcc-c++ make bzip2 bzip2-devel; do
		yum -y install ${NGINX_PKG}
	done
}

function Create_User()
{
	# ж $OWER ûǷڣ
	id ${OWER} >/dev/null 2>&1
	if [[ $? -eq '1' ]]; then
		useradd ${OWER} -M -s /sbin/nologin
	fi
}

function Nginx_Download()
{
	curl -L -O http://down.vqiu.cn/package/tarball/zlib/zlib-${ZLIB_VER}.tar.gz
	curl -L -O http://down.vqiu.cn/package/tarball/http/pcre-${PCRE_VER}.tar.bz2
	curl -L -O http://down.vqiu.cn/package/tarball/openssl/openssl-${OPENSSL_VER}.tar.gz
	curl -L -O http://mirrors.sohu.com/nginx/nginx-${NGINX_VER}.tar.gz
}

function Tengine_Download()
{
	curl -L -O http://down.vqiu.cn/package/tarball/zlib/zlib-${ZLIB_VER}.tar.gz
	curl -L -O http://down.vqiu.cn/package/tarball/http/pcre-${PCRE_VER}.tar.bz2
	curl -L -O http://down.vqiu.cn/package/tarball/openssl/openssl-${OPENSSL_VER}.tar.gz
	curl -L -O http://down.vqiu.cn/package/tarball/memory/jemalloc-${JEMALLOC_VER}.tar.bz2
	curl -L -O http://tengine.taobao.org/download/tengine-${TENGINE_VER}.tar.gz
}

function Zlib_Install()
{
#	tar axvf zlib-${ZLIB_VER}.tar.gz
#    cd zlib-${ZLIB_VER}
#	./configure
#	make -j${CPU_COUNTS}
#	make install
#	cd ../
}

function Pcre_Install()
{
	tar axvf pcre-${PCRE_VER}.tar.bz2
#	cd pcre-${PCRE_VER}
#	./configure
#	make -j${CPU_CORE};make install
#	cd ../
}

function Openssl_Install()
{	
	# Install Openssl
	tar axvf openssl-${OPENSSL_VER}.tar.gz
#    cd openssl-${OPENSSL_VER}
#	./config \
#	--prefix=/usr \
#	--openssldir=/etc/ssl \
#	--libdir=lib \
#	shared \
#	zlib-dynamic
#	make -j${CPU_COUNTS}
#	make install 
#
#	make MANDIR=/usr/share/man MANSUFFIX=ssl install &&
#	install -dv -m755 /usr/share/doc/openssl-${OPENSSL_VER}  &&
#	cp -vfr doc/*     /usr/share/doc/openssl-${OPENSSL_VER}
#	/sbin/ldconfig
#	cd ../
}

function Jemalloc_Install() {
    tar axvf jemalloc-${JEMALLOC_VER}.tar.bz2
    cd jemalloc-${JEMALLOC_VER}
    cd ../
}


function Nginx_Install()
{
    tar axvf nginx-${NGINX_VER}.tar.gz
    cd nginx-${NGINX_VER}
    ./configure \
	--prefix=${PREFIX}/nginx-${NGINX_VER} \
    --with-zlib=${SRC}/zlib-${ZLIB_VER} \
    --with-pcre=${SRC}/pcre-${PCRE_VER} \
    --with-openssl=$SRC/openssl-${OPENSSL_VER} \
	--with-http_v2_module \
    --user=${OWER} \
    --group=${OWER} \
    --with-http_ssl_module \
    --with-http_gzip_static_module \
    --with-http_realip_module \
    --with-http_stub_status_module \
	--with-http_gunzip_module \
	--with-file-aio \
	--with-threads \
	--with-pcre-jit
    make -j${CPU_CORE}
    make install
	
    
    if [[ -d ${PREFIX}/nginx-${NGINX_VER} ]]; then

        # ӣɾ
        if [[ -L ${PREFIX}/nginx ]]; then
            \rm -rf ${PREFIX}/nginx
        fi

        # 
		ln -sv ${PREFIX}/nginx-${NGINX_VER} ${PREFIX}/nginx
    else
		echo "Sorry,Nginx-${NGINX_VER} has been installed failed."
        exit 1
	fi

    #  systemd 
	cat > /usr/lib/systemd/system/nginx.service <<EOF
[Unit]
Description=The nginx HTTP and reverse proxy server
After=network.target remote-fs.target nss-lookup.target

[Service]
Type=forking
PIDFile=${PREFIX}/nginx/logs/nginx.pid
ExecStartPre=/usr/bin/rm -f /run/nginx.pid
ExecStartPre=${PREFIX}/nginx/sbin/nginx -t
ExecStart=${PREFIX}/nginx/sbin/nginx
ExecReload=/bin/kill -s HUP $MAINPID
KillMode=process
KillSignal=SIGQUIT
TimeoutStopSec=5
PrivateTmp=true

[Install]
WantedBy=multi-user.target
EOF

    # 
	systemctl restart nginx.service
    # ϵͳ
	systemctl enable nginx.service

    # ӵϵͳ
    echo -en "PATH=\$PATH:${PREFIX}/nginx/sbin" > /etc/profile.d/nginx.sh
}

function Tengine_Install()
{
    tar axvf tengine-${TENGINE_VER}.tar.gz
    cd tengine-${TENGINE_VER}
    ./configure --prefix=${PREFIX}/tengine-${TENGINE_VER} \
    --user=${OWER} \
    --group=${OWER} \
    --with-pcre=$SRC/pcre-${PCRE_VER} \
    --with-zlib=${SRC}/zlib-${ZLIB_VER} \
    --with-http_ssl_module \
    --with-openssl=$SRC/openssl-${OPENSSL_VER} \
    --with-jemalloc=$SRC/jemalloc-${JEMALLOC_VER} \
    --with-http_gzip_static_module \
    --with-http_realip_module \
    --with-http_stub_status_module \
    --with-http_concat_module
    make -j${CPU_CORE}
    make install
	
	
	if [[ -d ${PREFIX}/tengine-${TENGINE_VER} ]]; then

        # ӣɾ
        if [[ -L ${PREFIX}/nginx ]]; then
            \rm -rf ${PREFIX}/nginx
        fi

        # 
	    ln -sv ${PREFIX}/tengine-${TENGINE_VER} ${PREFIX}/nginx
    else
		echo "Sorry,Tengine-${TENGINE_VER} has been installed failed."
        exit 1
	fi

    # ӵϵͳ
    echo -en "PATH=\$PATH:${PREFIX}/nginx/sbin" > /etc/profile.d/nginx.sh
    echo "${PREFIX}/nginx/sbin/nginx" >> /etc/rc.local
}

echo -en ${boldgreen} "1) Install Nginx-${NGINX_VER} [Defalut]\n"
echo -en ${boldgreen} "2) Install Tengine-${TENGINE_VER}\n" ${black}
read -p "Please Enter Number:" SELECT

# Getting users to install version
case "${SELECT}" in
	1)
		echo "You will install Nginx-${NGINX_VER}"
		SELECT="Nginx"
		;;
	2)
		echo "You will install Tengine-${TENGINE_VER}"
		SELECT="Tengine"
		;;
	"")
		
		echo "You will install Nginx-${TENGINE_VER}"
		SELECT="Nginx"
		;;
	*)
		echo "INPUT error,You will install Nginx-${TENGINE_VER}"		
		SELECT="Nginx"
esac

if [[ ${SELECT} == "Nginx" ]]
then
	sleep 2
	Yum_Depend
	Create_User
	Nginx_Download
	Zlib_Install
	Pcre_Install
	Openssl_Install
	Nginx_Install
elif [[ ${SELECT} == "Tengine" ]]
then
	sleep 2
	Yum_Depend
	Create_User
	Tengine_Download
	Zlib_Install
	Pcre_Install
	Jemalloc_Install
	Openssl_Install
	Tengine_Install
fi
